import sys
import smbus

def _i2cType(addr):
  if addr == 0x3C:
    return "OLED"
  elif addr & 0x10:
    return "analog vertebra"
  elif addr & 0x20:
    return "digital vertebra"
  return "other I2C device"

def _list_devices(_bus):
  iotVertList = []
  for _address in range(3,120):
    try:
      _bus.read_byte(_address)
      # print('%s (0x%02x)' % (_i2cType(_address),_address))
      vertType = _i2cType(_address)
      if vertType == "analog vertebra" or vertType == "digital vertebra":
        iotVertList.append(_address)
    except:
      pass
  return iotVertList


try:
  iotVertList = _list_devices(smbus.SMBus(1))
  print(iotVertList)
except KeyboardInterrupt:
  print()
except Exception as _error:
  print('%s' % str(_error))
  sys.exit(1)
finally:
  sys.exit(0)
